import { ipcMain } from 'electron';
import IpcMainInvokeEvent = Electron.IpcMainInvokeEvent;
import {IPCAnswer, IPCChannel, IPCListenChannels, IPCRequest} from "./RawConstants";


export const IPCHandle = (
    channel: IPCChannel,
    listener: (
        event: IpcMainInvokeEvent,
        request: IPCRequest,
        ...args: any[]
    ) => Promise<IPCAnswer> | IPCAnswer
): void => {
    ipcMain.handle(channel, listener);
};

export const IPCSend = (
    channel: IPCListenChannels,
    message: IPCAnswer,
    ...args: any
): void => {
    console.log("Sending ", message, " to " + channel);

    global.mainWebContents.send(channel, message, ...args);
};