// See the Electron documentation for details on how to use preload scripts:
// https://www.electronjs.org/docs/latest/tutorial/process-model#preload-scripts

import {ipcRenderer, contextBridge} from 'electron';
import {IPCAnswer, IPCChannel, IPCRequest} from "./RawConstants";
import IpcRendererEvent = Electron.IpcRendererEvent;

contextBridge.exposeInMainWorld('api', {
    request: (channel: IPCChannel, request: IPCRequest, ...args: any): Promise<IPCAnswer> => {
        return ipcRenderer.invoke(channel, request, ...args);
    },
    listen: (channel: IPCChannel, func: (event: IpcRendererEvent, message: IPCAnswer, ...args: any) => void) => {
        ipcRenderer.on(channel, (event, message: IPCAnswer, ...args: any) => func(event, message, ...args));
    },
})