import {IPCAnswer, IPCListenChannels} from "../RawConstants";

type IPCListen = {
    channel: IPCListenChannels,
    fn: (message: IPCAnswer, ...args: any) => void,
}

export default class IPCRendererListener {
    private static attachments: Map<number, IPCListen> = new Map<number, IPCListen>();
    private static uID = 99;

    public static attach(event: IPCListenChannels, fn: (message: IPCAnswer, ...args: any) => void): number {
        this.uID++;
        this.attachments.set(this.uID, {fn: fn, channel: event});
        return this.uID;
    }

    public static detach(id: number)
    {
        this.attachments.delete(id);
    }


    public static initialAttach()
    {
        for(let c of Object.keys(IPCListenChannels))
        {
            window.api.listen((c as unknown as IPCListenChannels), (event, message: IPCAnswer, ...args: any) => {
                for(let [a, listener] of this.attachments)
                {
                    listener.fn(message, ...args);
                }
            });
        }
    }
}